--[[TP - Threat Plates Theme]]--

--[[Insert Local for Shared Media]]--

local Media = LibStub("LibSharedMedia-3.0")

--[[Set locals]]--

local config = {}
local path = "Interface\\Addons\\TidyPlates_ThreatPlates\\Artwork\\"
local fonts = "Interface\\Addons\\TidyPlates_ThreatPlates\\fonts\\"
local scale = 1
local xAdjust = 0
local yAdjust = 0

--[[Class Color ID]]--

local classByColor = {
C285 = "Deathknight",
C390 = "Druid",
C498 = "Hunter",
C549 = "Mage",
C571 = "Paladin",
C768 = "Priest",	
C605 = "Rogue",	
C335 = "Shaman",	
C479 = "Warlock",
C465 = "Warrior",
--C256 = "Npc",
}
--[[Set Texture]]--

function config.SetSpecialArt(unit)
	if unit.reaction == "HOSTILE" then
		local r = ceil(unit.red*256)
		local g = ceil(unit.green*256)
		local b = ceil(unit.blue*256)
		local class = nil
		local index = 0
		for index = -2, 3 do
			class = classByColor["C"..(r+g+b+index)]
			if class then return path.."\\Class\\ClassIcon_"..class end
		end
	end
	return nil
end

--[[Textures]]--

config.frame = {
	width = scale*124,
	height = scale*30,
}
config.threatborder = {
	texture =						path.."TP_Threat",
	elitetexture =					path.."TP_Threat",
	width = scale*256,
	height = scale*64,
	x = xAdjust+scale*0,
	y = yAdjust+scale*5,
	anchor = "CENTER",
}

config.healthborder = {
	texture = 						path.."TP_HealthBarOverlay",
	glowtexture = 					path.."TP_HealthBarHighlight",
	elitetexture = 					path.."TP_HealthBarEliteOverlay",
	width = scale*256,
	height = scale*64,
	x = xAdjust+scale*0,
	y = yAdjust+scale*5,
	anchor = "CENTER",
}
config.castborder = {
	texture = 						path.."TP_CastBarOverlay",
	width = scale*256,
	height = scale*64,
	x = xAdjust+scale*0,
	y = yAdjust+scale*-10,
	anchor = "CENTER",
}

config.castnostop = {
	texture =						path.."TP_CastBarLock",
	width = scale*256,
	height = scale*64,
	x = xAdjust+scale*0,
	y = yAdjust+scale*-10,
	anchor = "CENTER",
}
--[[Bar Textures]]--
config.healthbar = {
	texture =						path.."TP_BarTexture",
	width = scale*122,
	height = scale*12,
	x = xAdjust+scale*0,
	y = yAdjust+scale*5,
	anchor = "CENTER",
	orientation = "HORIZONTAL",
}
config.castbar = {
	texture =						path.."TP_BarTexture",
	width = scale*122,
	height = scale*12,
	x = xAdjust+scale*0,
	y = yAdjust+scale*-10,
	anchor = "CENTER",
	orientation = "HORIZONTAL",
}
--[[TEXT]]--

config.name = {
	typeface =						fonts.."Accidental Presidency.ttf",
	size = scale*12,
	width = scale*105,
	height = scale*14,
	x = xAdjust+scale*0,
	y = yAdjust+scale*18,
	align = "CENTER",
	anchor = "CENTER",
	vertical = "CENTER",
	shadow = true,
}
config.level = {
	typeface =						fonts.."Accidental Presidency.ttf",
	size = scale*12,
	width = scale*20,
	height = scale*14,
	x = xAdjust+scale*50,
	y = yAdjust+scale*5,
	align = "RIGHT",
	anchor = "CENTER",
	vertical = "TOP",
	shadow = true,
}
config.specialText = {
	typeface =						fonts.."Accidental Presidency.ttf",
	size = scale*12,
	width = scale*90,
	height = scale*14,
	x = xAdjust+scale*0,
	y = yAdjust+scale*6,
	align = "CENTER",
	anchor = "CENTER",
	vertical = "CENTER",
	shadow = true,
}
config.specialText2 = {
	typeface =						fonts.."Accidental Presidency.ttf",
	size = scale*12,
	width = scale*90,
	height = scale*14,
	x = xAdjust+scale*0,
	y = yAdjust+scale*0,
	align = "CENTER",
	anchor = "CENTER",
	vertical = "CENTER",
	shadow = true,
}
--[[ICONS]]--
config.dangerskull = {
	width = scale*14,
	height = scale*14,
	x = xAdjust+scale*58,
	y = yAdjust+scale*17,
	anchor = "CENTER",
}
config.specialArt = {
	width = scale*22,
	height = scale*22,
	x = xAdjust+scale*-74,
	y = yAdjust+scale*-2,
	anchor = "CENTER",
}
config.spellicon = {
	width = scale*20,
	height = scale*20,
	x = xAdjust+scale*75,
	y = yAdjust+scale*-2,
	anchor = "CENTER",
}
config.raidicon = {
	width = 14,
	height = 14,
	x = xAdjust+scale*0,
	y = yAdjust+scale*26,
	anchor = "CENTER",
}
--[[OPTIONS]]--
config.threatcolor = {
	LOW = { r = 0, g = 1, b = 0, a= 1, },
	MEDIUM = { r = 1, g = 1, b = 0, a= 1, },
	HIGH = { r = 1, g = 0, b = 0, a= 1, },
}
config.options = {
	showLevel = true,
	showName = true,
	showSpecialArt = true,
	showSpecialText = true,
	showSpecialText2 = true,
	showDangerSkull = true,
	showspellIcon = true,
	showNostopSpell = true,
}

--[[Health Truncate Function]]--

local Truncate = function(value)
	if value >= 1e6 then
		return format('%.1fm', value / 1e6)
	elseif value >= 1e4 then
		return format('%.1fk', value / 1e3)
	else
		return value
	end
end

--[[Special Text]]--

function config.SetSpecialText(unit)
	healthpercent = 100* (unit.health / unit.healthmax) 				--[[Creates the health percentage number]]--
	if (unit.health / unit.healthmax) < 1 then 							--[[If Health is less than 100%]]--
		return Truncate(unit.health).." - "..ceil(healthpercent ).."%" 	--[[Display Truncated HP Amount and Percentage]]--
	else 																--[[If HP is 100%]]--
		return ceil(healthpercent ).."%"								--[[Display Nothing or Optional 100% text]]--
	end
end

--[[function config.SetAlpha(unit)
	if (unit.health / unit.healthmax) > 0.5 then return 1
	else return .6 end
end
]]--

TidyPlatesThemeList["ThreatPlates"]["normal"] = {}
TidyPlatesThemeList["ThreatPlates"]["normal"] = config
